// radioactive-0.5/applet.cc

// RadioActive Copyright (C) 1999 RDI Gerg <cactus@cactus.rulez.org>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// (included in the RadioActive distribution in doc/GPL) as published by
// the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

// $Id: applet.cc,v 1.4 1999/06/10 21:11:44 cactus Exp $ -*- c++ -*-
#include "applet.h"
#include <strstream.h>

RApplet::RApplet(Radio& radiodev, wndMain& wnd):
    radio(radiodev),
    table(3, 2),
    label("1"),
    btnPrev("<"), btnNext(">"),
    btnMute(_("Mute")),
    w(wnd),
    button(0),
    prog_vals((RADIO_PROGBUTTON_COL) * (RADIO_PROGBUTTON_ROW),
	      (float)0)
{
    connect_to_method(btnMute.clicked, &radio, &radio.toggle_mute);
    connect_to_method(btnMute.clicked, &w, &wndMain::set);
    connect_to_method(btnPrev.clicked, this, &prev);
    connect_to_method(btnNext.clicked, this, &next);
    connect_to_method(w.btnMute_clicked, &btnMute, &btnMute.set_active);

    table.set_col_spacings(5);
//    table.set_row_spacings(2);
    table.set_border_width(1);
    label.set_justify(GTK_JUSTIFY_LEFT);
    label.set_alignment(0, 0.5);
    table.attach(label, 1, 2, 0, 1);
    table.attach(btnPrev, 0, 1, 0, 1);
    table.attach(btnNext, 2, 3, 0, 1);
    table.attach(btnMute, 0, 3, 1, 2);
    frame.add(table);
    frame.show_all();

    // C functions for accessing the panel applet itself
    applet = applet_widget_new("radioactive_applet");
    applet_widget_register_stock_callback(APPLET_WIDGET(applet),
					  "about",
					  GNOME_STOCK_MENU_ABOUT,
					  _("About"),
					  &show_about, NULL);
    applet_widget_register_stock_callback(APPLET_WIDGET(applet),
					  "window",
					  GNOME_STOCK_MENU_VOLUME,
					  _("Open window"),
					  &RApplet_show_wnd_cb, (RApplet*)this);
    
    applet_widget_add(APPLET_WIDGET(applet),
		      GTK_WIDGET(frame.gtkobj()));
}

int RApplet::get_num()
{
    return button;
}

void RApplet::set_num(int val)
{
    button = val;
    update_channel();
}

void RApplet::update_channel()
{
    strstream tmp;
    tmp << (button + 1) << ends;
    label.set(tmp.str());
//    if (w) w->set();
    w.set();
}

void RApplet::set_vals(vector<float> vals)
{
    prog_vals = vals;
}

void RApplet::next()
{
    if (++button > ((RADIO_PROGBUTTON_COL) * (RADIO_PROGBUTTON_ROW) - 1))
	button = 0;
    radio.set(prog_vals[button]);
    update_channel();
}

void RApplet::prev()
{
    if (--button < 0)
	button =  (RADIO_PROGBUTTON_COL) * (RADIO_PROGBUTTON_ROW) - 1;
    radio.set(prog_vals[button]);
    update_channel();
}

void RApplet::show()
{
    gtk_widget_show(applet);
}

void RApplet::show_about()
{
    wndMain::show_about();
}

void RApplet_show_wnd_cb(AppletWidget* caller, void* data)
{
    RApplet* inst = (RApplet*)data;
    inst->show_wnd();
}

void RApplet::show_wnd()
{
    w.set_speedtuner(prog_vals);
    w.set();
    w.show();
}
