// radioactive-0.5/applet.h

// RadioActive Copyright (C) 1999 RDI Gerg <cactus@cactus.rulez.org>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// (included in the RadioActive distribution in doc/GPL) as published by
// the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

// $Id: applet.h,v 1.3 1999/06/10 14:46:50 cactus Exp $ -*- c++ -*-
#ifndef RADIO_APPLET_H
#define RADIO_APPLET_H

#include "radioactive.h"
#include <gtk--.h>
#include <applet-widget.h>

#include "wndMain.h"
#include "driver.h"
#include "tuner.h"

void RApplet_show_wnd_cb(AppletWidget* caller, void* data);

class RApplet: public Gtk_Signal_Base
{
    Radio& radio;
    GtkWidget* applet;

    Gtk_Frame frame;
    Gtk_Table table;
    Gtk_Label label;
    Gtk_Button btnPrev, btnNext;
    Gtk_ToggleButton btnMute;
    wndMain& w;

    int button;
    vector<float> prog_vals;
public:
    RApplet(Radio& radiodev, wndMain& wnd);
    
    void show();
    void set_vals(vector<float> vals);
    int get_num();
    void set_num(int val);
private:
    void show_about();
    void show_wnd();
    void prev();
    void next();
    void update_channel();
	
    friend void RApplet_show_wnd_cb(AppletWidget* caller, void* data);
};

#endif /* RADIO_APPLET_H */
