// radioactive-0.5/file.cc

// RadioActive Copyright (C) 1999 RDI Gerg <cactus@cactus.rulez.org>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// (included in the RadioActive distribution in doc/GPL) as published by
// the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

#include "file.h"
#include "radioactive.h"

#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

string rc_file(const string& filename)
{
    string retval(getenv("HOME"));
    retval += (string)"/" + RADIO_RCDIR;

    struct stat buf;
    if (stat(retval.c_str(), &buf)){
	cout << "creating " << retval << endl;
	mkdir(retval.c_str(), 7*8*8);
    }

    retval += (string)"/" + filename;
    return retval;
}

vector<float> load_button_values(int num)
{
    vector<float> retval(num, (float)0);
    ifstream fin(rc_file("speedtuner").c_str());
    
    for (int i = 0; i < num; i++)
	fin >> retval[i];

    return retval;
}

void save_button_values(vector<float> values)
{
    ofstream fout(rc_file("speedtuner").c_str());

    for (vector<float>::iterator i = values.begin();
	 i != values.end(); i++)
	fout << *i << " ";
    fout << endl;
}
