// radioactive-0.5/file.h

// RadioActive Copyright (C) 1999 RDI Gerg <cactus@cactus.rulez.org>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// (included in the RadioActive distribution in doc/GPL) as published by
// the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

// $Id: file.h,v 1.3 1999/06/06 10:40:00 cactus Exp $ -*- c++ -*-
#ifndef RADIO_file
#define RADIO_file

#include <vector>
#include <fstream>
#include <string>

string rc_file(const string& filename);

vector<float> load_button_values(int num);
void save_button_values(vector<float> values);

template<class T>
inline void save_value(const string& filename, const T& data)
{
    ofstream fout(rc_file(filename).c_str());
    fout << data;
}

template<class T>
inline T load_value(const string& filename)
{
    T retval(0);
    ifstream fin(rc_file(filename).c_str());
    fin >> retval;
    return retval;
}

#endif
