// radioactive-0.5/speedtuner.cc

// RadioActive Copyright (C) 1999 RDI Gerg <cactus@cactus.rulez.org>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// (included in the RadioActive distribution in doc/GPL) as published by
// the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

// $Id: speedtuner.cc,v 1.5 1999/06/06 10:40:00 cactus Exp $
#include <strstream>

#include "speedtuner.h"

SpeedTuner::SpeedTuner(int row, int col):
    Gtk_Table(row, col),
    btnProg(row * col),
    prog_vals((row * col) - 1, (float)0)
{
    set_border_width(2);

    for (int i = 0; i < (row * col); i++)
    {
	strstream str_int;
	string label;
	str_int << (i + 1);
	label = str_int.str();
	Gtk_Button *b = new Gtk_Button(label);
	connect_to_method(b->clicked, this, &btnProg_clicked, i);
	connect_to_method(b->button_press_event, this,
			  &btnProg_mouse, i);
	b->set_usize(30, 30);
	
	gint left_attach = div(i, col).rem;
	gint top_attach = div(i, col).quot;
	attach(*b,
	       left_attach, left_attach + 1,
	       top_attach, top_attach + 1,
	       (GTK_FILL | GTK_EXPAND), (GTK_FILL | GTK_EXPAND),
	       2, 2);
	btnProg[i] = b;
    }
}

SpeedTuner::~SpeedTuner()
{
    for (vector<Gtk_Button*>::iterator i = btnProg.begin();
	 i != btnProg.end(); i++)
	delete *i;
}

void SpeedTuner::btnProg_clicked(int btn)
{
    clicked(prog_vals[btn]);
}

int SpeedTuner::btnProg_mouse(GdkEventButton *e, int btn)
{
    if (e->button == 3)
	rclicked(btn);
    return false;
}

void SpeedTuner::set(const vector<float>& values)
{
    prog_vals = values;
}

void SpeedTuner::set(int index, float value)
{
    prog_vals[index] = value;
}

vector<float> SpeedTuner::get()
{
    return prog_vals;
}
