// radioactive-0.5/tuner.cc

// RadioActive Copyright (C) 1999 RDI Gerg <cactus@cactus.rulez.org>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// (included in the RadioActive distribution in doc/GPL) as published by
// the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

// $Id: tuner.cc,v 1.8 1999/06/06 10:40:00 cactus Exp $
#include "tuner.h"
#include <math.h>

Tuner::Tuner(float min, float max):
    tuner_data(min, min, max, 0.5, 5)
{
    set_adjustment(tuner_data);
    set_digits(2);
    
    connect_to_method(tuner_data.value_changed, this, &tuner_changed);
    connect_to_method(set_value, this, &set_value_impl);
}

void Tuner::tuner_changed()
{
    float curr_value = tuner_data.get_value();
    double curr_value_int = rint((curr_value * 20));
    float rounded_value = (curr_value_int / 20);
    if (rounded_value != curr_value)
	tuner_data.set_value(rounded_value);
    else
	tune(rounded_value);
}

void Tuner::set_value_impl(float value)
{
    tuner_data.set_value(value);
}
