// radioactive-0.5/volume.cc

// RadioActive Copyright (C) 1999 RDI Gerg <cactus@cactus.rulez.org>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// (included in the RadioActive distribution in doc/GPL) as published by
// the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

// $Id: volume.cc,v 1.4 1999/06/05 17:20:00 cactus Exp $
#include "volume.h"

#include "radioactive.h"

Volume::Volume():
    Gtk_Table(1, 2),
    vol_adj(RADIO_VOL_MIN, RADIO_VOL_MIN, RADIO_VOL_MAX, 1, 3),
    vol_scale(vol_adj),
    btn(_("Mute"))
{
    vol_scale.set_draw_value(false);
    set_border_width(2);
    attach(vol_scale, 0, 1, 0, 1);
    vol_scale.set_digits(0);
    vol_scale.set_value_pos(GTK_POS_BOTTOM);
    attach(btn, 0, 1, 1, 2, GTK_EXPAND | GTK_FILL,
	   GTK_EXPAND | GTK_FILL, 2, 2);
    connect_to_method(btn.clicked, this, &mute_toggle);
    connect_to_method(vol_adj.value_changed, this, &volume_changed);
}

void Volume::set_mute(bool state)
{
    btn.set_active(state);
}

void Volume::mute_toggle()
{
    mute(btn.get_active());
}

void Volume::volume_changed()
{
    if (btn.get_active()) {
	btn.clicked();
    }
    change(RADIO_VOL_MAX - (int)vol_adj.get_value());
}

void Volume::set(int val)
{
    vol_adj.set_value(RADIO_VOL_MAX - val);
}

int Volume::get()
{
    return (RADIO_VOL_MAX - (int)vol_adj.get_value());
}
