// radioactive-0.5/wndMain.h

// RadioActive Copyright (C) 1999 RDI Gerg <cactus@cactus.rulez.org>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// (included in the RadioActive distribution in doc/GPL) as published by
// the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

// $Id: wndMain.h,v 1.19 1999/06/10 14:46:50 cactus Exp $ -*- c++ -*-
#ifndef RADIO_wndMain
#define RADIO_wndMain

#include "tuner.h"
#include "driver.h"
#include "speedtuner.h"
#include "volume.h"

#include <gtk--.h>
#include <gnome--.h>
#include <vector>

class wndMain: public Gtk_Window
{
    Radio& radio;
    Tuner tuner;
    SpeedTuner buttons;
    Volume volume;

    Gtk_Table tune_table;
    Gtk_Button fine_up, fine_down, up, down;
    Gtk_Label fine, normal;

    Gtk_HBox box;
    float curr_val;
public:
    wndMain(Radio& radiodev);

    void set_speedtuner(const vector<float>& values) {
	buttons.set(values);
    };
    vector<float> get_speedtuner() {
	return buttons.get();
    };
    static void show_about();
    void set();
    Signal1<bool> btnMute_clicked;
    
private:
    void build_table();
    void tuner_changed(float val);
    void speed_change(int btn);
    void tuner_fine_tune(float delta);
    static Gnome_About* about();
    int delete_event_impl(GdkEventAny* e);
};

#endif
